# all files / Github/bpmn-js/lib/features/modeling/behavior/ GroupBehavior.js

98.15% Statements 53/54
90.91% Branches 20/22
100% Functions 12/12
98.15% Lines 53/54

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186

    1128×

    16×
    16×

    16×

    8×
    8×
    8×

    8×

    8×

    8×
    7×

    7×

    7×

    14×
    105×

    14×

    66×

    66×

    1128×

    414×
    414×

    414×

    14×
    14×
    14×

    14×
    6×

    1128×

    94×
    94×

    94×

    4×
    4×
    4×
    4×

    4×
    4×

    1128×

    467×
    467×
    467×

    467×

    5×
    5×

    5×

    1128×

    93×
    93×

    93×

    2×

    2×

    1×

    1×import inherits from 'inherits';

    import CommandInterceptor from 'diagram-js/lib/command/CommandInterceptor';

    import {
      add as collectionAdd,
      remove as collectionRemove
    } from 'diagram-js/lib/util/Collections';

    import {
      getBusinessObject,
      is
    } from '../../../util/ModelUtil';

    import {
      createCategoryValue
    } from './util/CategoryUtil';

    /**
     * BPMN specific Group behavior
     */
    export default function GroupBehavior(eventBus, bpmnFactory, canvas, elementRegistry) {

      CommandInterceptor.call(this, eventBus);

      /**
       * Gets process definitions
       *
       * @return {ModdleElement} definitions
       */
      function getDefinitions() {
        var rootElement = canvas.getRootElement(),
            businessObject = getBusinessObject(rootElement);

        return businessObject.$parent;
      }

      /**
       * Removes a referenced category value for a given group shape
       *
       * @param {djs.model.Shape} shape
       */
      function removeReferencedCategoryValue(shape) {

        var businessObject = getBusinessObject(shape),
            categoryValue = businessObject.categoryValueRef,
            category = categoryValue.$parent;

        Iif (!categoryValue) {
          return;
        }

        collectionRemove(category.categoryValue, categoryValue);

        // cleanup category if it is empty
        if (category && !category.categoryValue.length) {
          removeCategory(category);
        }
      }

      /**
       * Removes a given category from the definitions
       *
       * @param {ModdleElement} category
       */
      function removeCategory(category) {

        var definitions = getDefinitions();

        collectionRemove(definitions.get('rootElements'), category);
      }

      /**
       * Returns all group element in the current registry
       *
       * @return {Array<djs.model.shape>} a list of group shapes
       */
      function getGroupElements() {
        return elementRegistry.filter(function(e) {
          return is(e, 'bpmn:Group');
        });
      }

      /**
       * Returns true if given categoryValue is referenced in one of the given elements
       *
       * @param {Array<djs.model.shape>} elements
       * @param {ModdleElement} categoryValue
       * @return {Boolean}
       */
      function isReferenced(elements, categoryValue) {
        return elements.some(function(e) {

          var businessObject = getBusinessObject(e);

          return businessObject.categoryValueRef
            && businessObject.categoryValueRef === categoryValue;
        });
      }

      /**
       * remove referenced category + value when group was deleted
       */
      this.executed('shape.delete', function(event) {

        var context = event.context,
            shape = context.shape;

        if (is(shape, 'bpmn:Group')) {

          var businessObject = getBusinessObject(shape),
              categoryValueRef = businessObject.categoryValueRef,
              groupElements = getGroupElements();

          if (!isReferenced(groupElements, categoryValueRef)) {
            removeReferencedCategoryValue(shape);
          }
        }
      });

      /**
       * re-attach removed category
       */
      this.reverted('shape.delete', function(event) {

        var context = event.context,
            shape = context.shape;

        if (is(shape, 'bpmn:Group')) {

          var businessObject = getBusinessObject(shape),
              categoryValueRef = businessObject.categoryValueRef,
              definitions = getDefinitions(),
              category = categoryValueRef ? categoryValueRef.$parent : null;

          collectionAdd(category.get('categoryValue'), categoryValueRef);
          collectionAdd(definitions.get('rootElements'), category);
        }
      });

      /**
       * create new category + value when group was created
       */
      this.execute('shape.create', function(event) {

        var context = event.context,
            shape = context.shape,
            businessObject = getBusinessObject(shape);

        if (is(businessObject, 'bpmn:Group') && !businessObject.categoryValueRef) {

          var definitions = getDefinitions(),
              categoryValue = createCategoryValue(definitions, bpmnFactory);

          // link the reference to the Group
          businessObject.categoryValueRef = categoryValue;

        }

      });

      this.revert('shape.create', function(event) {

        var context = event.context,
            shape = context.shape;

        if (is(shape, 'bpmn:Group')) {

          removeReferencedCategoryValue(shape);

          delete getBusinessObject(shape).categoryValueRef;

        }
      });

    }

    GroupBehavior.$inject = [
      'eventBus',
      'bpmnFactory',
      'canvas',
      'elementRegistry'
    ];

    inherits(GroupBehavior, CommandInterceptor);